/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_psub.c,v 1.2 1997/09/25 17:30:21 ae59 Exp $ */
/*
$Log: i_psub.c,v $
 * Revision 1.2  1997/09/25  17:30:21  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:02  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_psub.c                              */
/*                                                              */
/*      Entries         : void i_psub(cl,cu,a,b)                */
/*                        dotprecision *cl,*cu;                 */
/*                        a_intv a,b;                           */
/*                                                              */
/*      Arguments       : cl= dotprecision variable(lower bound)*/
/*                        cu= dotprecision variable(upper bound)*/
/*                        a = interval value                    */
/*                        b = interval value                    */
/*                                                              */
/*      Description     : Subtract product from dotprecision    */
/*                        variable                              */
/*                        c = c-a*b                             */
/*                                                              */
/*      Date            : 1991-01-22                            */
/*      1991-01-22 : r_pcmp() used for product comparison       */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
/* --- replaced by r_pcmp() ---
extern a_real *r_zero;
*/
#endif

#ifdef LINT_ARGS
local void i_psub(dotprecision *cl,dotprecision *cu,a_intv a,a_intv b)
#else
local void i_psub(cl,cu,a,b)

dotprecision *cl;
dotprecision *cu;
a_intv a;
a_intv b;
#endif
        {
        E_TPUSH("i_psub")

        if (r_sign(a.INF)>=0)
           {
           if (r_sign(b.INF)>=0)
              {
              d_psub(cu,a.INF,b.INF);
              d_psub(cl,a.SUP,b.SUP);
              }
           else if (r_sign(b.SUP)<=0)
              {
              d_psub(cu,a.SUP,b.INF);
              d_psub(cl,a.INF,b.SUP);
              }
           else
              {
              d_psub(cu,a.SUP,b.INF);
              d_psub(cl,a.SUP,b.SUP);
              }
           }
        else if (r_sign(a.SUP)<=0)
           {
           if (r_sign(b.INF)>=0)
              {
              d_psub(cu,a.INF,b.SUP);
              d_psub(cl,a.SUP,b.INF);
              }
           else if (r_sign(b.SUP)<=0)
              {
              d_psub(cu,a.SUP,b.SUP);
              d_psub(cl,a.INF,b.INF);
              }
           else
              {
              d_psub(cu,a.INF,b.SUP);
              d_psub(cl,a.INF,b.INF);
              }
           }
        else
           {
           if (r_sign(b.INF)>=0)
              {
              d_psub(cu,a.INF,b.SUP);
              d_psub(cl,a.SUP,b.SUP);
              }
           else if (r_sign(b.SUP)<=0)
              {
              d_psub(cu,a.SUP,b.INF);
              d_psub(cl,a.INF,b.INF);
              }
           else
              {
/* --- replaced by r_pcmp() ---
              dotprecision q;
              d_init(&q);

              d_clr(&q);
              d_padd(&q,a.INF,b.SUP);
              d_psub(&q,a.SUP,b.INF);
              if (r_gt(d_stau(q),*r_zero))
*/
              if (r_pcmp(a.INF,b.SUP,a.SUP,b.INF)>0)
                 d_psub(cu,a.SUP,b.INF);
              else
                 d_psub(cu,a.INF,b.SUP);

/* --- replaced by r_pcmp() ---
              d_clr(&q);
              d_padd(&q,a.INF,b.INF);
              d_psub(&q,a.SUP,b.SUP);
              if (r_gt(d_stau(q),*r_zero))
*/
              if (r_pcmp(a.INF,b.INF,a.SUP,b.SUP)>0)
                 d_psub(cl,a.INF,b.INF);
              else
                 d_psub(cl,a.SUP,b.SUP);

/* --- replaced by r_pcmp() ---
              d_free(&q);
*/
              }
           }

        E_TPOPP("i_psub")
        return;
        }

